#!/usr/bin/perl
# arrange.pl : JgfBNgȉ̃t@CweʖɃfBNg֐U蕪

use File::Copy;
use File::Path;

print "Searching files...\n";
system("/bin/ls -laR --show-control-chars > /tmp/files.list");

print "Arranging files...\n";

open LST, "/tmp/files.list" || die "Can't open file list\n";

$size = 0;
$dir  = "";
$dir_prefix = "data_";	# U蕪fBNgvtBbNX
$size_limit = 4580000;		# U蕪e
$index = 0;				# CfbNXl
$total = 0;
$dst_dir = "";
$firstdir = "";
$olddir = "";

while(<LST>) {
	chomp;
	if(/\.\/(.+)\:/) {
		next if($_ eq "." || $_ eq "..");
		$srcdir = $1;
		$dstdir = $index if($dstdir eq "");
		printf "  <%s: %d>\n", $srcdir, $size;
	}
	if(/^([drwxls\-+]+)\s+\d+\s+\S+\s+\S+\s+(\d+)\s+\S+\s+\S+\s+\S+\s+(.+)/) {
		$type = $1;
#		print "$type\n";
		$filesize = int((($2 + 2047) / 2048) * 2) + 2;
#		$3 =~ /\"(.+)\"/;
		$file = sprintf("%s/%s", $srcdir, $3);
		next if($type =~ /d[rwx-]+/);

		#print "$filesize $file\n";
		if($size + $filesize >= $size_limit) {
			open DST, ">/tmp/$index.lst";
			#$olddir = "";
			foreach $file0 (@filelist) {
				#$file0 =~ /^(.+)\/[^\/]+$/;
				#$srcpath = $1;
				$dstpath = sprintf("%s%03d/%s", $dir_prefix, $index, $file0);
#				print DST "[$dstpath][$file0]\n";
				$dstpath =~ /^(.+)\/[^\/]+$/;
				$newdir = $1;
				if($newdir ne $olddir) {
					print DST "$newdir\n";
					unless(-d $newdir) {
						print "Make directory [$newdir]\n";
						mkpath ([$newdir], 1, 0700);
					}
				} 
				move($file0, $dstpath);
				printf DST "  $dstpath\n";
				$olddir = $newdir;
			}
			close DST;
			$newdir = sprintf("%s%03d/%s", $dir_prefix, $dstdir, $srcdir);
			$filecount = @filelist;
			printf "Directory: %s\n  [%d KB: %d files]\n", $newdir, $size, $filecount;
			$total += $size;
			$size = $filesize;
			$index++;
			$dstdir = $index;
			undef @filelist;
		} else {
			$size += $filesize;
		}
		push(@filelist, $file);
	}
}

printf "#%s: %d\n", $srcdir, $size;
printf "Total %d\n", $total;
close LST;
